static INPUT: &str = include_str!("01.txt");

fn main() {
    let mut counter = 0;
    INPUT.lines().fold(None, |last, line| {
        let cur: u32 = line.parse().expect("line must be numeric");
        if let Some(last) = last {
            if cur > last {
                counter += 1;
            }
        }
        Some(cur)
    });
    println!("increased {} times", counter);

    let mut counter = 0;
    let splitted: Vec<u32> = INPUT
        .lines()
        .map(|line| line.parse().expect("line must be a number"))
        .collect();
    splitted
        .windows(3)
        .map(|win| {
            if let [a, b, c] = win {
                a + b + c
            } else {
                unreachable!("line must be a number")
            }
        })
        .fold(None, |last, cur| {
            if let Some(last) = last {
                if cur > last {
                    counter += 1;
                }
            }
            Some(cur)
        });
    println!("increased {} times", counter);
}
