static INPUT: &str = include_str!("02.txt");

fn main() {
    // part 1
    let mut pos: i32 = 0;
    let mut depth: i32 = 0;
    INPUT
        .lines()
        .map(|line| {
            let mut line = line.splitn(2, " ");
            let direction = line.next().expect("no direction set");
            let delta: i32 = line
                .next()
                .expect("no delta set")
                .parse()
                .expect("delta must be a number");
            match direction {
                "forward" => pos += delta,
                "down" => depth += delta,
                "up" => depth -= delta,
                _ => unimplemented!("unknown direction instruction"),
            }
        })
        .count();
    println!("---");
    println!("pos: {}, depth: {}", pos, depth);
    println!("result: {}", pos * depth);

    // part 2
    let mut pos: i32 = 0;
    let mut depth: i32 = 0;
    let mut aim: i32 = 0;
    INPUT
        .lines()
        .map(|line| {
            let mut line = line.splitn(2, " ");
            let direction = line.next().expect("no direction set");
            let delta: i32 = line
                .next()
                .expect("no delta set")
                .parse()
                .expect("delta must be a number");
            match direction {
                "forward" => {
                    pos += delta;
                    depth += aim * delta;
                }
                "down" => aim += delta,
                "up" => aim -= delta,
                _ => unimplemented!("unknown direction instruction"),
            }
        })
        .count();
    println!("---");
    println!("pos: {}, depth: {}", pos, depth);
    println!("result: {}", pos * depth)
}
